;;; syntax: #[1 2 3 ...] for ordinary queues, #{1 2 3 ...} for funcallable ones
(macrolet ((def (name open close)
               (let ((reader-name (intern (format nil "~A-~A" name 'reader))))
                 `(progn 
                   (defun ,reader-name (stream char n)
                     (declare (ignore char n))
                     (let ((contents (read-delimited-list ,close stream t))
                           (result (make-instance ',name)))
                       (dolist (o contents result) (enqueue o result))))
                   (set-dispatch-macro-character #\# ,open ',reader-name)
                   (set-syntax-from-char ,close #\))
                   (defmethod print-object ((o ,name) stream)
                     (when (and *print-readably* (not (eq (class-of o) (find-class ',name))))
                       (call-next-method))
                     (format stream "#~C" ,open)
                     (do ((data (cdr (%queue-data o)) (cdr data)) (i 0 (1+ i)))
                         ((null data) (format stream "~C" ,close) o)
                       (unless (or *print-readably* (not *print-length*))
                         (when (= i *print-length*)
                           (format stream "...~C" ,close)
                           (return o)))
                       (let ((*print-level* (and *print-level* (1- *print-level*))))
                         (write (car data) :stream stream))
                       (unless (null (cdr data)) (format stream " "))))))))
  (def queue #\[ #\]) (def funcallable-queue #\{ #\}))
