(in-package "SEQUENCE-TESTS")

(deftest count.queue.1
    (count t #[])
  0)

(deftest count.queue.2
    (count t #[t])
  1)

(deftest count.queue.3
    (count t #[nil])
  0)

(deftest count.queue.4
    (count t #[nil a b t 4 5 t y])
  2)

(deftest count.queue.5
    (count t #[nil a b t 4 5 t y] :test 'eql)
  2)

(deftest count.queue.6
    (count t #[nil a b t 4 5 t y] :test #'eql)
  2)

(deftest count.queue.7
    (count t #[nil a b t 4 5 t y] :key 'not)
  1)

(deftest count.queue.8
    (count t #[nil a b t 4 5 t y] :key #'not)
  1)

(deftest count.queue.9
    (let ((c 0))
      (count 1 #[1 2 3 1 4 1 7 6 1 8]
	     :key (lambda (x) (prog1 (- x c) (incf c)))))
  4)

(deftest count.queue.10
    (let ((c 0))
      (count 1 #[1 2 3 7 4 5 7 6 2 8]
	     :from-end t
	     :key (lambda (x) (prog1 (- x c) (incf c)))))
  3)

(deftest count.queue.11
    (count 1 #[1 1 1 1 1 2 1 1] :start 3)
  4)

(deftest count.queue.12
    (count 1 #[1 1 1 1 1 2 1 1] :end 6)
  5)

(deftest count.queue.13
    (count 1 #[1 1 1 1 1 2 1 1] :start 2 :end 7)
  4)

(deftest count.queue.14
    (count 1 #[1 1 1 1 1 2 1 1] :start 3 :end nil)
  4)

(deftest count.queue.15
    (count 1 #[1 1 1 1 1 2 1 1] :end nil)
  7)

(deftest count.queue.16
    (count 1 #[1 1 1 1 1 2 1 1] :test-not #'eql)
  1)

(deftest count.queue.17
    (count 1 #[1 1 1 1 1 2 1 1] :test-not 'eql)
  1)

(deftest count.queue.18
    (count 1 #[1 1 1 3 1 2 1 1] :start 2 :end 7
	   :test (constantly t))
  5)

(deftest count.queue.19
    (count 10 #[1 11 2 4 14 5 18 6 7] :test #'<)
  3)

(deftest count.queue.20
    (count 10 #[1 11 2 4 14 5 18 6 7] :test-not #'>=)
  3)

(deftest count-if.queue.1
    (count-if #'null #[])
  0)

(deftest count-if.queue.2
    (count-if #'null #[t])
  0)

(deftest count-if.queue.3
    (count-if #'null #[nil])
  1)

(deftest count-if.queue.4
    (count-if 'keywordp #[nil a b t 4 5 t y])
  0)

(deftest count-if.queue.5
    (count-if #'null #[nil a b t 4 5 t y])
  1)

(deftest count-if.queue.6
    (count-if 'null #[nil a b t 4 5 t y])
  1)

(deftest count-if.queue.7
    (count-if #'identity #[nil a b t 4 5 t y] :key 'not)
  1)

(deftest count-if.queue.8
    (count-if #'identity #[nil a b t 4 5 t y] :key #'not)
  1)

(deftest count-if.queue.9
    (let ((c 0))
      (count-if (lambda (x) (= x 1)) #[1 2 3 1 4 1 7 6 1 8]
		:key (lambda (x) (prog1 (- x c) (incf c)))))
  4)

(deftest count-if.queue.10
    (let ((c 0))
      (count-if (lambda (x) (= x 1)) #[1 2 3 7 4 5 7 6 2 8]
		:from-end t
		:key (lambda (x) (prog1 (- x c) (incf c)))))
  3)

(deftest count-if.queue.11
    (count-if #'oddp #[1 1 1 1 1 2 1 1] :start 3)
  4)

(deftest count-if.queue.12
    (count-if #'oddp #[1 1 1 1 1 2 1 1] :end 6)
  5)

(deftest count-if.queue.13
    (count-if #'oddp #[1 1 1 1 1 2 1 1] :start 2 :end 7)
  4)

(deftest count-if.queue.14
    (count-if #'oddp #[1 1 1 1 1 2 1 1] :start 3 :end nil)
  4)

(deftest count-if.queue.15
    (count-if #'oddp #[1 1 1 1 1 2 1 1] :end nil)
  7)

(deftest count-if.queue.16
    (count-if #'evenp #[1 1 1 1 1 2 1 1])
  1)

(deftest count-if.queue.17
    (count-if 'evenp #[1 1 1 1 1 2 1 1])
  1)

(deftest count-if.queue.18
    (count-if (constantly t) #[1 1 1 3 1 2 1 1] :start 2 :end 7)
  5)

(deftest count-if.queue.19
    (count-if (lambda (x) (< x 10)) #[1 11 2 4 14 5 18 6 7])
  6)

(deftest count-if.queue.20
    (count-if (lambda (x) (>= 10 x)) #[1 11 2 4 14 5 18 6 7])
  6)

(deftest count-if-not.queue.1
    (count-if-not #'null #[])
  0)

(deftest count-if-not.queue.2
    (count-if-not #'null #[t])
  1)

(deftest count-if-not.queue.3
    (count-if-not #'null #[nil])
  0)

(deftest count-if-not.queue.4
    (count-if-not 'keywordp #[nil a b t 4 5 t y])
  8)

(deftest count-if-not.queue.5
    (count-if-not #'null #[nil a b t 4 5 t y])
  7)

(deftest count-if-not.queue.6
    (count-if-not 'null #[nil a b t 4 5 t y])
  7)

(deftest count-if-not.queue.7
    (count-if-not #'identity #[nil a b t 4 5 t y] :key 'not)
  7)

(deftest count-if-not.queue.8
    (count-if-not #'identity #[nil a b t 4 5 t y] :key #'not)
  7)

(deftest count-if-not.queue.9
    (let ((c 0))
      (count-if-not (lambda (x) (= x 1)) #[1 2 3 1 4 1 7 6 1 8]
		    :key (lambda (x) (prog1 (- x c) (incf c)))))
  6)

(deftest count-if-not.queue.10
    (let ((c 0))
      (count-if-not (lambda (x) (= x 1)) #[1 2 3 7 4 5 7 6 2 8]
		    :from-end t
		    :key (lambda (x) (prog1 (- x c) (incf c)))))
  7)

(deftest count-if-not.queue.11
    (count-if-not #'oddp #[1 1 1 1 1 2 1 1] :start 3)
  1)

(deftest count-if-not.queue.12
    (count-if-not #'oddp #[1 1 1 1 1 2 1 1] :end 6)
  1)

(deftest count-if-not.queue.13
    (count-if-not #'oddp #[1 1 1 1 1 2 1 1] :start 2 :end 7)
  1)

(deftest count-if-not.queue.14
    (count-if-not #'oddp #[1 1 1 1 1 2 1 1] :start 3 :end nil)
  1)

(deftest count-if-not.queue.15
    (count-if-not #'oddp #[1 1 1 1 1 2 1 1] :end nil)
  1)

(deftest count-if-not.queue.16
    (count-if-not #'evenp #[1 1 1 1 1 2 1 1])
  7)

(deftest count-if-not.queue.17
    (count-if-not 'evenp #[1 1 1 1 1 2 1 1])
  7)

(deftest count-if-not.queue.18
    (count-if-not (constantly t) #[1 1 1 3 1 2 1 1] :start 2 :end 7)
  0)

(deftest count-if-not.queue.19
    (count-if-not (lambda (x) (< x 10)) #[1 11 2 4 14 5 18 6 7])
  3)

(deftest count-if-not.queue.20
    (count-if-not (lambda (x) (>= 10 x)) #[1 11 2 4 14 5 18 6 7])
  3)

(deftest count.queue.order.1
    (let ((i 0) c1 c2 c3 c4 c5 c6 c7)
      (values
       (count (progn (setf c1 (incf i)) nil)
	      (progn (setf c2 (incf i)) #[a nil b c nil d e])
	      :start (progn (setf c3 (incf i)) 0)
	      :end (progn (setf c4 (incf i)) 3)
	      :key (progn (setf c5 (incf i)) #'identity)
	      :from-end (progn (setf c6 (incf i)) nil)
	      :test (progn (setf c7 (incf i)) #'eql))
       i c1 c2 c3 c4 c5 c6 c7))
  1 7 1 2 3 4 5 6 7)

(deftest count.queue.order.2
    (let ((i 0) c1 c2 c3 c4 c5 c6 c7)
      (values
       (count (progn (setf c1 (incf i)) nil)
	      (progn (setf c2 (incf i)) #[a nil b c nil d e])
	      :test (progn (setf c3 (incf i)) #'eql)
	      :from-end (progn (setf c4 (incf i)) nil)
	      :key (progn (setf c5 (incf i)) #'identity)
	      :end (progn (setf c6 (incf i)) 3)
	      :start (progn (setf c7 (incf i)) 0))
       i c1 c2 c3 c4 c5 c6 c7))
  1 7 1 2 3 4 5 6 7)

(deftest count.queue.allow-other-keys.1
    (count 'a #[b a d a c] :bad t :allow-other-keys t)
  2)

(deftest count.queue.allow-other-keys.2
    (count 'a #[b a d a c] :allow-other-keys #p"*" :bad t)
  2)

(deftest count.queue.allow-other-keys.3
    (count 'a #[b a d a c] 
	   :allow-other-keys t :allow-other-keys nil :bad t)
  2)

(deftest count.queue.keywords.4
    (count 2 #[1 2 3 2 5] :key 'identity :key '1+)
  2)

(deftest count.queue.allow-other-keys.5
    (count 'a #[a b c a] :allow-other-keys nil)
  2)
