(in-package "SEQUENCE-TESTS")

(deftest fill.queue.1
    (let* ((a (copy-seq #[a b c d e]))
           (b (fill a 'x)))
      (values (eql a b) (map 'list #'identity a)))
  t (x x x x x))

(deftest fill.queue.2
    (let* ((a (copy-seq #[a b c d e]))
           (b (fill a 'x :start 2)))
      (values (eql a b) (map 'list #'identity a)))
  t (a b x x x))

(deftest fill.queue.3
    (let* ((a (copy-seq #[a b c d e]))
           (b (fill a 'x :end 2)))
      (values (eql a b) (map 'list #'identity a)))
  t (x x c d e))

(deftest fill.queue.4
    (let* ((a (copy-seq #[a b c d e]))
           (b (fill a 'x :start 1 :end 3)))
      (values (eql a b) (map 'list #'identity a)))
  t (a x x d e))

(deftest fill.queue.5
    (let* ((a (copy-seq #[a b c d e]))
           (b (fill a 'x :start 1 :end nil)))
      (values (eql a b) (map 'list #'identity a)))
  t (a x x x x))

(deftest fill.queue.6
    (let* ((a (copy-seq #[a b c d e]))
           (b (fill a 'x :end nil)))
      (values (eql a b) (map 'list #'identity a)))
  t (x x x x x))
