(in-package "SEQUENCE-TESTS")

(deftest mismatch.queue.1a
    (mismatch #[] '(a b c))
  0)
(deftest mismatch.queue.1b
    (mismatch '() #[a b c])
  0)
(deftest mismatch.queue.1c
    (mismatch #[] #[a b c])
  0)

(deftest mismatch.queue.2a
    (mismatch #[a b c d] '())
  0)
(deftest mismatch.queue.2b
    (mismatch '(a b c d) #[])
  0)
(deftest mismatch.queue.2c
    (mismatch #[a b c d] #[])
  0)

(deftest mismatch.queue.3a
    (mismatch #[a b c] '(a b c))
  nil)
(deftest mismatch.queue.3b
    (mismatch '(a b c) #[a b c])
  nil)
(deftest mismatch.queue.3c
    (mismatch #[a b c] #[a b c])
  nil)

(deftest mismatch.queue.4a
    (mismatch #[a b c] '(a b d))
  2)
(deftest mismatch.queue.4b
    (mismatch '(a b c) #[a b d])
  2)
(deftest mismatch.queue.4c
    (mismatch #[a b c] #[a b d])
  2)

(deftest mismatch.queue.5a
    (mismatch #[a b c] '(b c) :start1 1)
  nil)
(deftest mismatch.queue.5b
    (mismatch '(a b c) #[b c] :start1 1)
  nil)
(deftest mismatch.queue.5c
    (mismatch #[a b c] #[b c] :start1 1)
  nil)

(deftest mismatch.queue.6a
    (mismatch #[a b c d] '(z b c e) :start1 1 :start2 1)
  3)
(deftest mismatch.queue.6b
    (mismatch '(a b c d) #[z b c e] :start1 1 :start2 1)
  3)
(deftest mismatch.queue.6c
    (mismatch #[a b c d] #[z b c e] :start1 1 :start2 1)
  3)

(deftest mismatch.queue.7a
    (mismatch #[a b c d] '(z b c e) :start1 1 :start2 1 :end1 3 :end2 3)
  nil)
(deftest mismatch.queue.7b
    (mismatch '(a b c d) #[z b c e] :start1 1 :start2 1 :end1 3 :end2 3)
  nil)
(deftest mismatch.queue.7c
    (mismatch #[a b c d] #[z b c e] :start1 1 :start2 1 :end1 3 :end2 3)
  nil)

(deftest mismatch.queue.8a
    (mismatch #[1 2 3 4] '(5 6 7 8) :test #'(lambda (x y) (= x (- y 4))))
  nil)
(deftest mismatch.queue.8b
    (mismatch '(1 2 3 4) #[5 6 7 8] :test #'(lambda (x y) (= x (- y 4))))
  nil)
(deftest mismatch.queue.8c
    (mismatch #[1 2 3 4] #[5 6 7 8] :test #'(lambda (x y) (= x (- y 4))))
  nil)

(deftest mismatch.queue.9a
    (mismatch #[1 2 3 4] '(5 6 17 8) :test #'(lambda (x y) (= x (- y 4))))
  2)
(deftest mismatch.queue.9b
    (mismatch '(1 2 3 4) #[5 6 17 8] :test #'(lambda (x y) (= x (- y 4))))
  2)
(deftest mismatch.queue.9c
    (mismatch #[1 2 3 4] #[5 6 17 8] :test #'(lambda (x y) (= x (- y 4))))
  2)

(deftest mismatch.queue.10a
    (mismatch #[1 2 3 4] '(10 11 7 123) :test-not #'(lambda (x y) (= x (- y 4))))
  2)
(deftest mismatch.queue.10b
    (mismatch '(1 2 3 4) #[10 11 7 123] :test-not #'(lambda (x y) (= x (- y 4))))
  2)
(deftest mismatch.queue.10c
    (mismatch #[1 2 3 4] #[10 11 7 123] :test-not #'(lambda (x y) (= x (- y 4))))
  2)

(deftest mismatch.queue.11a
    (mismatch #[1 2 3 4] '(5 6 17 8) :key #'evenp)
  nil)
(deftest mismatch.queue.11b
    (mismatch '(1 2 3 4) #[5 6 17 8] :key #'evenp)
  nil)
(deftest mismatch.queue.11c
    (mismatch #[1 2 3 4] #[5 6 17 8] :key #'evenp)
  nil)

(deftest mismatch.queue.12a
    (mismatch #[1 2 3 4] '(5 6 12 8) :key 'oddp)
  2)
(deftest mismatch.queue.12b
    (mismatch '(1 2 3 4) #[5 6 12 8] :key 'oddp)
  2)
(deftest mismatch.queue.12c
    (mismatch #[1 2 3 4] #[5 6 12 8] :key 'oddp)
  2)

(deftest mismatch.queue.13a
    (mismatch #[1 2 3 4] '(1 2 3 4) :test 'eql)
  nil)
(deftest mismatch.queue.13b
    (mismatch '(1 2 3 4) #[1 2 3 4] :test 'eql)
  nil)
(deftest mismatch.queue.13c
    (mismatch #[1 2 3 4] #[1 2 3 4] :test 'eql)
  nil)

(deftest mismatch.queue.14a
    (mismatch #[1 2 3 4] '(5 6 7 8) :test-not 'eql)
  nil)
(deftest mismatch.queue.14b
    (mismatch '(1 2 3 4) #[5 6 7 8] :test-not 'eql)
  nil)
(deftest mismatch.queue.14c
    (mismatch #[1 2 3 4] #[5 6 7 8] :test-not 'eql)
  nil)

(deftest mismatch.queue.15a
    (mismatch #[a b c d e f g h i j k] '(a b c c e f g h z j k))
  3)
(deftest mismatch.queue.15b
    (mismatch '(a b c d e f g h i j k) #[a b c c e f g h z j k])
  3)
(deftest mismatch.queue.15c
    (mismatch #[a b c d e f g h i j k] #[a b c c e f g h z j k])
  3)

(deftest mismatch.queue.16a
    (mismatch #[a b c d e f g h i j k] '(a b c c y f g h z j k) :from-end t)
  9)
(deftest mismatch.queue.16b
    (mismatch '(a b c d e f g h i j k) #[a b c c y f g h z j k] :from-end t)
  9)
(deftest mismatch.queue.16c
    (mismatch #[a b c d e f g h i j k] #[a b c c y f g h z j k] :from-end t)
  9)

(deftest mismatch.queue.17a
    (mismatch #[a b c] '(a b c a b c d) :from-end t)
  3)
(deftest mismatch.queue.17b
    (mismatch '(a b c) #[a b c a b c d] :from-end t)
  3)
(deftest mismatch.queue.17c
    (mismatch #[a b c] #[a b c a b c d] :from-end t)
  3)

(deftest mismatch.queue.18a
    (mismatch #[a b c a b c d] '(a b c) :from-end t)
  7)
(deftest mismatch.queue.18b
    (mismatch '(a b c a b c d) #[a b c] :from-end t)
  7)
(deftest mismatch.queue.18c
    (mismatch #[a b c a b c d] #[a b c] :from-end t)
  7)

(deftest mismatch.queue.19a
    (mismatch #[1 1 1] '(2 2 2 2 2 1 2 2) :from-end t :test-not 'eql)
  1)
(deftest mismatch.queue.19b
    (mismatch '(1 1 1) #[2 2 2 2 2 1 2 2] :from-end t :test-not 'eql)
  1)
(deftest mismatch.queue.19c
    (mismatch #[1 1 1] #[2 2 2 2 2 1 2 2] :from-end t :test-not 'eql)
  1)

(deftest mismatch.queue.20a
    (mismatch #[1 1 1 1 1 1 1] '(2 3 3) :from-end t :key #'evenp)
  5)
(deftest mismatch.queue.20b
    (mismatch '(1 1 1 1 1 1 1) #[2 3 3] :from-end t :key #'evenp)
  5)
(deftest mismatch.queue.20c
    (mismatch #[1 1 1 1 1 1 1] #[2 3 3] :from-end t :key #'evenp)
  5)

(deftest mismatch.queue.21a
    (mismatch #[1 1 1] '(2 2 2 2 2 1 2 2) :from-end t :test-not #'equal)
  1)
(deftest mismatch.queue.21b
    (mismatch '(1 1 1) #[2 2 2 2 2 1 2 2] :from-end t :test-not #'equal)
  1)
(deftest mismatch.queue.21c
    (mismatch #[1 1 1] #[2 2 2 2 2 1 2 2] :from-end t :test-not #'equal)
  1)

(deftest mismatch.queue.22a
    (mismatch #[1 1 1 1 1 1 1] '(2 3 3) :from-end t :key 'evenp)
  5)
(deftest mismatch.queue.22b
    (mismatch '(1 1 1 1 1 1 1) #[2 3 3] :from-end t :key 'evenp)
  5)
(deftest mismatch.queue.22c
    (mismatch #[1 1 1 1 1 1 1] #[2 3 3] :from-end t :key 'evenp)
  5)

(deftest mismatch.queue.keywords.6
    (mismatch "1234" #[#\1 #\2 #\4 #\4] 
              :test #'equal :test (complement #'equal))
  2)
