(in-package "SEQUENCE-TESTS")

(deftest position.queue.1
    (position 'c #[a b c d e c a])
  2)

(deftest position.queue.2
    (position 'c #[a b c d e c a] :from-end t)
  5)

(deftest position.queue.3
    (loop for i from 0 to 7 collect
	  (position 'c #[a b c d e c a] :start i))
  (2 2 2 5 5 5 nil nil))

(deftest position.queue.4
    (loop for i from 0 to 7 collect
	  (position 'c #[a b c d e c a] :start i :end nil))
  (2 2 2 5 5 5 nil nil))

(deftest position.queue.5
    (loop for i from 7 downto 0 collect
	  (position 'c #[a b c d e c a] :end i))
  (2 2 2 2 2 nil nil nil))

(deftest position.queue.6
    (loop for i from 0 to 7 collect
	  (position 'c #[a b c d e c a] :start i :from-end t))
  (5 5 5 5 5 5 nil nil))

(deftest position.queue.7
    (loop for i from 0 to 7 collect
	  (position 'c #[a b c d e c a] :start i :end nil :from-end t))
  (5 5 5 5 5 5 nil nil))

(deftest position.queue.8
    (loop for i from 7 downto 0 collect
	  (position 'c #[a b c d e c a] :end i :from-end t))
  (5 5 2 2 2 nil nil nil))

(deftest position.queue.9
    (loop for i from 0 to 6 collect
	  (loop for j from (1+ i) to 7
		collect
		(position 'c #[a b c d e c a] :start i :end j)))
  ((nil nil 2 2 2 2 2) (nil 2 2 2 2 2) (2 2 2 2 2)
   (nil nil 5 5) (nil 5 5) (5 5) (nil)))

(deftest position.queue.10
    (loop for i from 0 to 6 collect
	  (loop for j from (1+ i) to 7
		collect
		(position 'c #[a b c d e c a] :start i :end j :from-end t)))
  ((nil nil 2 2 2 5 5) (nil 2 2 2 5 5) (2 2 2 5 5)
   (nil nil 5 5) (nil 5 5) (5 5) (nil)))

(deftest position.queue.11
    (position 5 #[1 2 3 4 5 6 4 8] :key #'1+)
  3)

(deftest position.queue.12
    (position 5 #[1 2 3 4 5 6 4 8] :key '1+)
  3)

(deftest position.queue.13
    (position 5 #[1 2 3 4 5 6 4 8] :key #'1+ :from-end t)
  6)

(deftest position.queue.14
    (position 'a #[a a b a c e d a f a] :test (complement #'eql))
  2)

(deftest position.queue.15
    (position 'a #[a a b a c e d a f a] 
	      :test (complement #'eql) :from-end t)
  8)

(deftest position.queue.16
    (position 'a #[a a b a c e d a f a] :test-not #'eql)
  2)

(deftest position.queue.17
    (position 'a #[a a b a c e d a f a] :test-not 'eql :from-end t)
  8)

(deftest position.queue.18
    (position 'a #[a a b a c e d a f a] :test-not 'eql)
  2)

(deftest position.queue.19
    (position 'a #[a a b a c e d a f a] :test-not #'eql :from-end t)
  8)

(deftest position.queue.20
    (position 'a #[a a b a c e d a f a] :test-not #'eql)
  2)

(deftest position.queue.21
    (position 'a #[a a b a c e d a f a] :test #'eql :start 2)
  3)

(deftest position.queue.22
    (position 'a #[a a b a c e d a f a] :test #'eql :start 2 :end nil)
  3)

(deftest position.queue.23
    (position 'a #[a a b a c e d a f a] :test-not #'eql :start 0 :end 5)
  2)

(deftest position.queue.24
    (position 'a #[a a b a c e d a f a] :test-not #'eql 
	      :start 0 :end 5 :from-end t)
  4)

(deftest position.queue.25
    (position "ab" #["a" #(#\b #\a) #(#\a #\b #\c)
	             #(#\a #\b) #(#\d #\e) f] :test #'equalp)
  3)

(deftest position.queue.26
    (position 'a #[(c) (b a) (a b c) (a b) (d e) f] :key #'car)
  2)

(deftest position.queue.27
    (position 'a #[(c) (b a) (a b c) (z) (a b) (d e) f] :key #'car :start 3)
  4)

(deftest position.queue.28
    (position 'a #[(c) (b a) (a b c) (z) (a b) (d e) (f)]
	      :key #'car :start 2 :from-end t)
  4)

(deftest position.queue.29
    (position 10 #[1 2 3 8 20 3 1 21 3] :test #'<)
  4)

(deftest position.queue.30
    (position 10 #[1 2 3 8 20 3 1 21 3] :test-not #'>=)
  4)

(deftest position.queue.allow-other-keys.1
    (position 0 #[1 2 3 4 5] :key #'(lambda (x) (mod x 2))
	      :bad t :allow-other-keys t)
  1)

(deftest position.queue.allow-other-keys.2
    (position 0 #[1 2 3 4 5] :key #'(lambda (x) (mod x 2))
	      :allow-other-keys t :also-bad t)
  1)

;;; The leftmost of two :allow-other-keys arguments is the one that  matters.
(deftest position.queue.allow-other-keys.3
    (position 0 '#[1 2 3 4 5] :key #'(lambda (x) (mod x 2))
	      :allow-other-keys t :allow-other-keys nil :bad t)
  1)

(deftest position.queue.keywords.4
    (position 2 #[1 2 3 4 5] :key #'identity :key #'1+)
  1)

(deftest position.queue.allow-other-keys.5
    (position 'b #[nil a b c nil] :allow-other-keys nil)
  2)

(deftest position-if.queue.1
    (position-if #'identity #[])
  nil)

(deftest position-if.queue.2
    (position-if #'identity #[a])
  0)

(deftest position-if.queue.2a
    (position-if 'identity #[a])
  0)

(deftest position-if.queue.3
    (position-if #'evenp #[1 2 4 8 3 1 6 7])
  1)

(deftest position-if.queue.4
    (position-if #'evenp #[1 2 4 8 3 1 6 7] :from-end t)
  6)

(deftest position-if.queue.5
    (loop for i from 0 to 7 collect
	  (position-if #'evenp #[1 2 4 8 3 1 6 7] :start i))
  (1 1 2 3 6 6 6 nil))

(deftest position-if.queue.6
    (loop for i from 0 to 7 collect
	  (position-if #'evenp #[1 2 4 8 3 1 6 7] :start i :end nil))
  (1 1 2 3 6 6 6 nil))

(deftest position-if.queue.7
    (loop for i from 0 to 7 collect
	  (position-if #'evenp #[1 2 4 8 3 1 6 7] :start i :from-end t))
  (6 6 6 6 6 6 6 nil))

(deftest position-if.queue.8
    (loop for i from 0 to 7 collect
	  (position-if #'evenp #[1 2 4 8 3 1 6 7] :start i :end nil :from-end t))
  (6 6 6 6 6 6 6 nil))

(deftest position-if.queue.9
    (loop for i from 0 to 8 collect
	  (position-if #'evenp #[1 2 4 8 3 1 6 7] :end i))
  (nil nil 1 1 1 1 1 1 1))

(deftest position-if.queue.10
    (loop for i from 0 to 8 collect
	  (position-if #'evenp #[1 2 4 8 3 1 6 7] :end i :from-end t))
  (nil nil 1 2 3 3 3 6 6))

(deftest position-if.queue.11
    (loop for j from 0 to 7
	  collect
	  (loop for i from (1+ j) to 8 collect
		(position-if #'evenp #[1 2 4 8 3 1 6 7] :start j :end i)))
  ((nil 1 1 1 1 1 1 1) (1 1 1 1 1 1 1) (2 2 2 2 2 2)
   (3 3 3 3 3) (nil nil 6 6) (nil 6 6) (6 6) (nil)))

(deftest position-if.queue.12
    (loop for j from 0 to 7
	  collect
	  (loop for i from (1+ j) to 8 collect
		(position-if #'evenp #[1 2 4 8 3 1 6 7] :start j :end i
			 :from-end t)))
  ((nil 1 2 3 3 3 6 6) (1 2 3 3 3 6 6) (2 3 3 3 6 6)
   (3 3 3 6 6) (nil nil 6 6) (nil 6 6) (6 6) (nil)))

(deftest position-if.queue.13
    (loop for i from 0 to 6
	  collect
	  (position-if #'evenp #[1 6 11 32 45 71 100] :key #'1+ :start i))
  (0 2 2 4 4 5 nil))

(deftest position-if.queue.14
    (loop for i from 0 to 6
	  collect
	  (position-if #'evenp #[1 6 11 32 45 71 100] 
		   :key '1+ :start i :from-end t))
  (5 5 5 5 5 5 nil))

(deftest position-if.queue.15
    (loop for i from 0 to 7
	  collect
	  (position-if #'evenp #[1 6 11 32 45 71 100] :key #'1+ :end i))
  (nil 0 0 0 0 0 0 0))

(deftest position-if.queue.16
    (loop for i from 0 to 7
	  collect
	  (position-if #'evenp #[1 6 11 32 45 71 100] :key '1+ :end i :from-end t))
  (nil 0 0 2 2 4 5 5))

(deftest position-if.queue.17
    (loop for j from 0 to 7
	  collect
	  (loop for i from (1+ j) to 8 collect
		(position-if #'oddp #[1 2 4 8 3 1 6 7] :start j :end i :key #'1-)))
  ((nil 1 1 1 1 1 1 1) (1 1 1 1 1 1 1) (2 2 2 2 2 2)
   (3 3 3 3 3) (nil nil 6 6) (nil 6 6) (6 6) (nil)))

(deftest position-if.queue.18
    (loop for j from 0 to 7
	  collect
	  (loop for i from (1+ j) to 8 collect
		(position-if #'oddp #[1 2 4 8 3 1 6 7] :start j :end i
			 :from-end t :key #'1+)))
  ((nil 1 2 3 3 3 6 6) (1 2 3 3 3 6 6) (2 3 3 3 6 6)
   (3 3 3 6 6) (nil nil 6 6) (nil 6 6) (6 6) (nil)))

(deftest position-if.queue.allow-other-keys.1
    (position-if #'evenp #[1 2 3 4 5] :bad t :allow-other-keys t)
  1)

(deftest position-if.queue.allow-other-keys.2
    (position-if #'evenp #[1 2 3 4 5] :allow-other-keys t :also-bad t)
  1)

(deftest position-if.queue.allow-other-keys.3
    (position-if #'evenp #[1 2 3 4 5]
		 :allow-other-keys t :allow-other-keys nil :bad t)
  1)

(deftest position-if.queue.keywords.4
    (position-if #'evenp #[1 2 3 4 5] :key #'identity :key #'1+)
  1)

(deftest position-if.queue.allow-other-keys.5
    (position-if #'identity #[nil a b c nil] :allow-other-keys nil)
  1)

(deftest position-if.queue.order.1
    (let ((i 0) x y)
      (values
       (position-if (progn (setf x (incf i)) #'identity)
		    (progn (setf y (incf i)) #[nil nil nil a nil nil]))
       i x y))
  3 2 1 2)

(deftest position-if.queue.order.2
  (let ((i 0) a b c d e f)
    (values
     (position-if (progn (setf a (incf i)) #'null)
		  (progn (setf b (incf i)) #[nil nil nil a nil nil])
		  :start (progn (setf c (incf i)) 1)
		  :end   (progn (setf d (incf i)) 4)
		  :from-end (setf e (incf i))
		  :key   (progn (setf f (incf i)) #'null))
     i a b c d e f))
  3 6 1 2 3 4 5 6)


(deftest position-if.order.3
  (let ((i 0) a b c d e f)
    (values
     (position-if (progn (setf a (incf i)) #'null)
		  (progn (setf b (incf i)) #[nil nil nil a nil nil])
		  :key   (progn (setf c (incf i)) #'null)
		  :from-end (setf d (incf i))
		  :end   (progn (setf e (incf i)) 4)
		  :start (progn (setf f (incf i)) 1))
     i a b c d e f))
  3 6 1 2 3 4 5 6)

(deftest position-if-not.queue.1
    (position-if-not #'identity #[])
  nil)

(deftest position-if-not.queue.2
    (position-if-not #'null #[a])
  0)

(deftest position-if-not.queue.2a
    (position-if-not 'null #[a])
  0)

(deftest position-if-not.queue.3
    (position-if-not #'oddp #[1 2 4 8 3 1 6 7])
  1)

(deftest position-if-not.queue.4
    (position-if-not #'oddp #[1 2 4 8 3 1 6 7] :from-end t)
  6)

(deftest position-if-not.queue.5
    (loop for i from 0 to 7 collect
	  (position-if-not #'oddp #[1 2 4 8 3 1 6 7] :start i))
  (1 1 2 3 6 6 6 nil))

(deftest position-if-not.queue.6
    (loop for i from 0 to 7 collect
	  (position-if-not #'oddp #[1 2 4 8 3 1 6 7] :start i :end nil))
  (1 1 2 3 6 6 6 nil))

(deftest position-if-not.queue.7
    (loop for i from 0 to 7 collect
	  (position-if-not #'oddp #[1 2 4 8 3 1 6 7] :start i :from-end t))
  (6 6 6 6 6 6 6 nil))

(deftest position-if-not.queue.8
    (loop for i from 0 to 7 collect
	  (position-if-not #'oddp #[1 2 4 8 3 1 6 7] 
		       :start i :end nil :from-end t))
  (6 6 6 6 6 6 6 nil))

(deftest position-if-not.queue.9
    (loop for i from 0 to 8 collect
	  (position-if-not #'oddp #[1 2 4 8 3 1 6 7] :end i))
  (nil nil 1 1 1 1 1 1 1))

(deftest position-if-not.queue.10
    (loop for i from 0 to 8 collect
	  (position-if-not #'oddp #[1 2 4 8 3 1 6 7] :end i :from-end t))
  (nil nil 1 2 3 3 3 6 6))

(deftest position-if-not.queue.11
    (loop for j from 0 to 7
	  collect
	  (loop for i from (1+ j) to 8 collect
		(position-if-not #'oddp #[1 2 4 8 3 1 6 7] :start j :end i)))
  ((nil 1 1 1 1 1 1 1) (1 1 1 1 1 1 1) (2 2 2 2 2 2)
   (3 3 3 3 3) (nil nil 6 6) (nil 6 6) (6 6) (nil)))

(deftest position-if-not.queue.12
    (loop for j from 0 to 7
	  collect
	  (loop for i from (1+ j) to 8 collect
		(position-if-not #'oddp #[1 2 4 8 3 1 6 7] :start j :end i
			     :from-end t)))
  ((nil 1 2 3 3 3 6 6) (1 2 3 3 3 6 6) (2 3 3 3 6 6)
   (3 3 3 6 6) (nil nil 6 6) (nil 6 6) (6 6) (nil)))

(deftest position-if-not.queue.13
    (loop for i from 0 to 6
	  collect
	  (position-if-not #'oddp #[1 6 11 32 45 71 100] :key #'1+ :start i))
  (0 2 2 4 4 5 nil))

(deftest position-if-not.queue.14
    (loop for i from 0 to 6
	  collect
	  (position-if-not #'oddp #[1 6 11 32 45 71 100]
		       :key '1+ :start i :from-end t))
  (5 5 5 5 5 5 nil))

(deftest position-if-not.queue.15
    (loop for i from 0 to 7
	  collect
	  (position-if-not #'oddp #[1 6 11 32 45 71 100] :key #'1+ :end i))
  (nil 0 0 0 0 0 0 0))

(deftest position-if-not.queue.16
    (loop for i from 0 to 7
	  collect
	  (position-if-not #'oddp #[1 6 11 32 45 71 100] 
		       :key '1+ :end i :from-end t))
  (nil 0 0 2 2 4 5 5))

(deftest position-if-not.queue.17
    (loop for j from 0 to 7
	  collect
	  (loop for i from (1+ j) to 8 collect
		(position-if-not #'evenp #[1 2 4 8 3 1 6 7] :start j :end i :key #'1-)))
  ((nil 1 1 1 1 1 1 1) (1 1 1 1 1 1 1) (2 2 2 2 2 2)
   (3 3 3 3 3) (nil nil 6 6) (nil 6 6) (6 6) (nil)))

(deftest position-if-not.queue.18
    (loop for j from 0 to 7
	  collect
	  (loop for i from (1+ j) to 8 collect
		(position-if-not #'evenp #[1 2 4 8 3 1 6 7] :start j :end i
			     :from-end t :key #'1+)))
  ((nil 1 2 3 3 3 6 6) (1 2 3 3 3 6 6) (2 3 3 3 6 6)
   (3 3 3 6 6) (nil nil 6 6) (nil 6 6) (6 6) (nil)))

(deftest position-if-not.queue.allow-other-keys.1
    (position-if-not #'oddp #[1 2 3 4 5] :bad t :allow-other-keys t)
  1)

(deftest position-if-not.queue.allow-other-keys.2
    (position-if-not #'oddp #[1 2 3 4 5] :allow-other-keys t :also-bad t)
  1)

;;; The leftmost of two :allow-other-keys arguments is the one that  matters.
(deftest position-if-not.queue.allow-other-keys.3
    (position-if-not #'oddp #[1 2 3 4 5]
		     :allow-other-keys t :allow-other-keys nil :bad t)
  1)

(deftest position-if-not.queue.keywords.4
    (position-if-not #'oddp #[1 2 3 4 5] :key #'identity :key #'1+)
  1)

(deftest position-if-not.queue.allow-other-keys.5
    (position-if-not #'null #[nil a b c nil] :allow-other-keys nil)
  1)

(deftest position-if-not.queue.order.1
    (let ((i 0) x y)
      (values
       (position-if-not (progn (setf x (incf i)) #'null)
			(progn (setf y (incf i)) #[nil nil nil a nil nil]))
       i x y))
  3 2 1 2)

(deftest position-if-not.queue.order.2
  (let ((i 0) a b c d e f)
    (values
     (position-if-not (progn (setf a (incf i)) #'identity)
		      (progn (setf b (incf i)) #[nil nil nil a nil nil])
		      :start (progn (setf c (incf i)) 1)
		      :end   (progn (setf d (incf i)) 4)
		      :from-end (setf e (incf i))
		      :key   (progn (setf f (incf i)) #'null))
     i a b c d e f))
  3 6 1 2 3 4 5 6)


(deftest position-if-not.queue.order.3
  (let ((i 0) a b c d e f)
    (values
     (position-if-not (progn (setf a (incf i)) #'identity)
		      (progn (setf b (incf i)) #[nil nil nil a nil nil])
		      :key   (progn (setf c (incf i)) #'null)
		      :from-end (setf d (incf i))
		      :end   (progn (setf e (incf i)) 4)
		      :start (progn (setf f (incf i)) 1))
     i a b c d e f))
  3 6 1 2 3 4 5 6)
