(in-package "SEQUENCE-TESTS")

(deftest reduce.queue.1
    (reduce #'cons #[a b c d e f])
  (((((a . b) . c) . d) . e) . f))

(deftest reduce.queue.2
    (reduce #'cons #[a b c d e f] :from-end t)
  (a b c d e . f))

(deftest reduce.queue.3
    (reduce #'cons #[a b c d e f] :initial-value 'z)
  ((((((z . a) . b) . c) . d) . e) . f))

(deftest reduce.queue.4
    (reduce #'cons #[a b c d e f] :initial-value 'g :from-end t)
  (a b c d e f . g))

(deftest reduce.queue.5
    (reduce #'cons #[a b c d e f] :from-end nil)
  (((((a . b) . c) . d) . e) . f))

(deftest reduce.queue.6
    (reduce #'cons #[a b c d e f] :from-end 17)
  (a b c d e . f))

(deftest reduce.queue.7
    (reduce #'cons #[a b c d e f] :end nil)
  (((((a . b) . c) . d) . e) . f))

(deftest reduce.queue.8
    (reduce #'cons #[a b c d e f] :end 3)
  ((a . b) . c))

(deftest reduce.queue.9
    (reduce #'cons #[a b c d e f] :start 1 :end 4)
  ((b . c) . d))

(deftest reduce.queue.10
    (reduce #'cons #[a b c d e f] :start 1 :end 4 :from-end t)
  (b c . d))

(deftest reduce.queue.11
    (reduce #'cons #[a b c d e f] :start 1 :end 4 :from-end t
            :initial-value nil)
  (b c d))

(deftest reduce.queue.12
    (reduce 'cons #[a b c d e f])
  (((((a . b) . c) . d) . e) . f))

(deftest reduce.queue.13
    (reduce #'+ #[])
  0)

(deftest reduce.queue.14
    (reduce #'+ #[1 2 3] :start 0 :end 0)
  0)

(deftest reduce.queue.15
    (reduce #'+ #[1 2 3] :key '1+)
  9)

(deftest reduce.queue.16
    (reduce #'cons #[1 2 3] :key '1+ :from-end t :initial-value nil)
  (2 3 4))

(deftest reduce.queue.17
    (reduce #'+ #[1 2 3 4 5 6 7] :key '1+ :start 2 :end 6)
  22)
