(in-package "SEQUENCE-TESTS")

(deftest remove-duplicates.queue.1
    (let* ((orig #[1 2 3 4 1 3 4 1 2 5 6 2 7])
           (y (remove-duplicates orig :key nil)))
      (values (eql orig y) (coerce y 'list)))
  nil (3 4 1 5 6 2 7))

(deftest remove-duplicates.queue.2
    (let* ((orig #[1 2 3 4 1 3 4 1 2 5 6 2 7])
           (y (remove-duplicates orig :from-end t)))
      (values (eql orig y) (coerce y 'list)))
  nil (1 2 3 4 5 6 7))

(deftest remove-duplicates.queue.3
    (let* ((orig #[1 2 3 4 1 3 4 1 2 5 6 2 7])
           (y (remove-duplicates orig :from-end t :key 'oddp)))
      (values (eql orig y) (coerce y 'list)))
  nil (1 2))

(deftest remove-duplicates.queue.4
    (let* ((orig #[1 2 3 4 1 3 4 1 2 5 6 2 7])
           (y (remove-duplicates orig :from-end nil :key 'oddp)))
      (values (eql orig y) (coerce y 'list)))
  nil (2 7))

(deftest remove-duplicates.queue.5
    (let* ((orig #[1 2 3 4 1 3 4 1 2 5 6 2 7])
           (y (remove-duplicates orig :from-end t :start 2 :end 7 :key 'oddp)))
      (values (eql orig y) (coerce y 'list)))
  nil (1 2 3 4 1 2 5 6 2 7))

(deftest remove-duplicates.queue.6
    (let* ((orig #[1 2 3 4 1 3 4 1 2 5 6 2 7])
           (y (remove-duplicates orig :start 2 :end 8 :key 'oddp)))
      (values (eql orig y) (coerce y 'list)))
  nil (1 2 4 1 2 5 6 2 7))

(deftest remove-duplicates.queue.keywords.1
    (let* ((orig #[1 2 3 4 2 7 8 1 5])
           (y (remove-duplicates orig :from-end t :from-end nil)))
      (values (eql orig y) (coerce y 'list)))
  nil (1 2 3 4 7 8 5))

(deftest/sequence delete-duplicates.queue.1
    (let* ((orig (copy-seq #[1 2 3 4 1 3 4 1 2 5 6 2 7]))
           (y (delete-duplicates orig :key nil)))
      y)
  #[3 4 1 5 6 2 7])

(deftest/sequence delete-duplicates.queue.2
    (let* ((orig (copy-seq #[1 2 3 4 1 3 4 1 2 5 6 2 7]))
           (y (delete-duplicates orig :from-end t)))
      y)
  #[1 2 3 4 5 6 7])

(deftest/sequence delete-duplicates.queue.3
    (let* ((orig (copy-seq #[1 2 3 4 1 3 4 1 2 5 6 2 7]))
           (y (delete-duplicates orig :from-end t :key 'oddp)))
      y)
  #[1 2])

(deftest/sequence delete-duplicates.queue.4
    (let* ((orig (copy-seq #[1 2 3 4 1 3 4 1 2 5 6 2 7]))
           (y (delete-duplicates orig :from-end nil :key 'oddp)))
      y)
  #[2 7])

(deftest/sequence delete-duplicates.queue.5
    (let* ((orig (copy-seq #[1 2 3 4 1 3 4 1 2 5 6 2 7]))
           (y (delete-duplicates orig :from-end t :start 2 :end 7 :key 'oddp)))
      y)
  #[1 2 3 4 1 2 5 6 2 7])

(deftest/sequence delete-duplicates.queue.6
    (let* ((orig (copy-seq #[1 2 3 4 1 3 4 1 2 5 6 2 7]))
           (y (delete-duplicates orig :start 2 :end 8 :key 'oddp)))
      y)
  #[1 2 4 1 2 5 6 2 7])

(deftest/sequence delete-duplicates.keywords.1
    (let* ((orig (copy-seq #[1 2 3 4 2 7 8 1 5]))
           (y (delete-duplicates orig :from-end t :from-end nil)))
      y)
  #[1 2 3 4 7 8 5])
