(in-package "SEQUENCE-TESTS")

(deftest/sequence remove.queue.1
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (remove 'a x)))
      (and (sequence-equal orig x) y))
  #[b c b d c b e])

(deftest/sequence remove.queue.2
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (remove 'a x :count nil)))
      (and (sequence-equal orig x) y))
  #[b c b d c b e])

(deftest/sequence remove.queue.3
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (remove 'a x :key nil)))
      (and (sequence-equal orig x) y))
  #[b c b d c b e])

(deftest/sequence remove.queue.4
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (remove 'a x :count 100)))
      (and (sequence-equal orig x) y))
 #[b c b d c b e])

(deftest/sequence remove.queue.5
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (remove 'a x :count 0)))
      (and (sequence-equal orig x) y))
  #[a b c a b d a c b a e])

(deftest/sequence remove.queue.6
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (remove 'a x :count 1)))
      (and (sequence-equal orig x) y))
  #[b c a b d a c b a e])

(deftest/sequence remove.queue.7
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (remove 'c x :count 1)))
      (and (sequence-equal orig x) y))
  #[a b a b d a c b a e])

(deftest/sequence remove.queue.8
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (remove 'a x :from-end t)))
      (and (sequence-equal orig x) y))
  #[b c b d c b e])

(deftest/sequence remove.queue.9
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (remove 'a x :from-end t :count 1)))
      (and (sequence-equal orig x) y))
  #[a b c a b d a c b e])

(deftest/sequence remove.queue.10
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (remove 'a x :from-end t :count 4)))
      (and (sequence-equal orig x) y))
  #[b c b d c b e])

(deftest remove.queue.11
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig)))
      (values
       (loop for i from 0 to 10
             collect (coerce (remove 'a x :start i) 'list))
       (sequence-equal orig x)))
  ((b c b d c b e)
   (a b c b d c b e)
   (a b c b d c b e)
   (a b c b d c b e)
   (a b c a b d c b e)
   (a b c a b d c b e)
   (a b c a b d c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b a e))
  t)

(deftest remove.queue.12
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig)))
      (values
       (loop for i from 0 to 10
             collect (coerce (remove 'a x :start i :end nil) 'list))
       (sequence-equal orig x)))
  ((b c b d c b e)
   (a b c b d c b e)
   (a b c b d c b e)
   (a b c b d c b e)
   (a b c a b d c b e)
   (a b c a b d c b e)
   (a b c a b d c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b a e))
  t)

(deftest remove.queue.13
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig)))
      (values
       (loop for i from 0 to 10
             collect (coerce (remove 'a x :start i :end 11) 'list))
       (sequence-equal orig x)))
  ((b c b d c b e)
   (a b c b d c b e)
   (a b c b d c b e)
   (a b c b d c b e)
   (a b c a b d c b e)
   (a b c a b d c b e)
   (a b c a b d c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b a e))
  t)

(deftest/sequence remove.queue.14
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (remove 'a x :end nil)))
      (and (sequence-equal orig x) y))
  #[b c b d c b e])
 
(deftest remove.queue.15
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig)))
      (values
       (loop for i from 0 to 9
             collect (coerce (remove 'a x :start i :end 9) 'list))
       (sequence-equal orig x)))
  ((b c b d c b a e)
   (a b c b d c b a e)
   (a b c b d c b a e)
   (a b c b d c b a e)
   (a b c a b d c b a e)
   (a b c a b d c b a e)
   (a b c a b d c b a e)
   (a b c a b d a c b a e)
   (a b c a b d a c b a e)
   (a b c a b d a c b a e))
  t)

(deftest remove.queue.16
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig)))
      (values
       (loop for i from 0 to 10
             collect (coerce (remove 'a x :start i :end 11 :count 1) 'list))
       (sequence-equal orig x)))
  ((b c a b d a c b a e)
   (a b c b d a c b a e)
   (a b c b d a c b a e)
   (a b c b d a c b a e)
   (a b c a b d c b a e)
   (a b c a b d c b a e)
   (a b c a b d c b a e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b a e))
  t)

(deftest remove.queue.17
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig)))
      (values
       (loop for i from 0 to 10
             collect (coerce (remove 'a x :start i :end (1+ i)) 'list))
       (sequence-equal orig x)))
  ((  b c a b d a c b a e)
   (a b c a b d a c b a e)
   (a b c a b d a c b a e)
   (a b c   b d a c b a e)
   (a b c a b d a c b a e)
   (a b c a b d a c b a e)
   (a b c a b d   c b a e)
   (a b c a b d a c b a e)
   (a b c a b d a c b a e)
   (a b c a b d a c b   e)
   (a b c a b d a c b a e))
  t)

#|
(deftest remove.queue.18
   (let* ((i (1+ most-positive-fixnum))
	  (orig (list i 0 i 1 i 2 3))
	  (x (copy-seq orig))
	  (y (remove (1+ most-positive-fixnum) x)))
     (and (sequence-equal orig x) y))
   (0 1 2 3))
|#

(deftest/sequence remove.queue.19
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (remove 1 x :key #'1-)))
      (and (sequence-equal orig x) y))
  #[1 3 6 1 4 1 3 7])

(deftest/sequence remove.queue.20
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (remove 3 x :test #'>)))
      (and (sequence-equal orig x) y))
  #[3 6 4 3 7])

(deftest/sequence remove.queue.21
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (remove 3 x :test '> :from-end t)))
      (and (sequence-equal orig x) y))
  #[3 6 4 3 7])

(deftest/sequence remove.queue.22
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (remove 2 x :key nil)))
      (and (sequence-equal orig x) y))
  #[1 3 6 1 4 1 3 7])

(deftest/sequence remove.queue.23
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (remove 1 x :key '1-)))
      (and (sequence-equal orig x) y))
  #[1 3 6 1 4 1 3 7])

(deftest/sequence remove.queue.24
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (remove 3 x :test-not #'<=)))
      (and (sequence-equal orig x) y))
  #[3 6 4 3 7])

(deftest/sequence remove.queue.25
  (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
	 (x (copy-seq orig))
	 (y (remove 3 x :test-not '<= :from-end t)))
    (and (sequence-equal orig x) y))
  #[3 6 4 3 7])

(deftest/sequence remove.queue.26
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (remove 3 x :from-end t :start 1 :end 5)))
      (and (sequence-equal orig x) y))
  #[1 2 2 6 1 2 4 1 3 2 7])

(deftest remove.queue.27
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (remove 3 x :count -1)))
      (and (sequence-equal orig x)
           (sequence-equal x y)))
  t)

(deftest remove.queue.28
  (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
	 (x (copy-seq orig))
	 (y (remove 3 x :count -1000000000000)))
    (and (sequence-equal orig x)
	 (sequence-equal x y)))
  t)

(deftest/sequence remove.queue.29
  (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
	 (x (copy-seq orig))
	 (y (remove 3 x :count 1000000000000)))
    (and (sequence-equal orig x) y))
  #[1 2 2 6 1 2 4 1 2 7])

(deftest/sequence delete.queue.1
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (delete 'a x)))
      y)
  #[b c b d c b e])

(deftest/sequence delete.queue.2
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (delete 'a x :count nil)))
      y)
  #[b c b d c b e])

(deftest/sequence delete.queue.3
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (delete 'a x :key nil)))
      y)
  #[b c b d c b e])

(deftest/sequence delete.queue.4
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (delete 'a x :count 100)))
      y)
 #[b c b d c b e])

(deftest/sequence delete.queue.5
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (delete 'a x :count 0)))
      y)
  #[a b c a b d a c b a e])

(deftest/sequence delete.queue.6
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (delete 'a x :count 1)))
      y)
  #[b c a b d a c b a e])

(deftest/sequence delete.queue.7
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (delete 'c x :count 1)))
      y)
  #[a b a b d a c b a e])

(deftest/sequence delete.queue.8
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (delete 'a x :from-end t)))
      y)
  #[b c b d c b e])

(deftest/sequence delete.queue.9
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (delete 'a x :from-end t :count 1)))
      y)
  #[a b c a b d a c b e])

(deftest/sequence delete.queue.10
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (delete 'a x :from-end t :count 4)))
      y)
  #[b c b d c b e])

(deftest delete.queue.11
    (let* ((orig #[a b c a b d a c b a e]))
      (loop for i from 0 to 10
	    for x = (copy-seq orig)
	    collect (coerce (delete 'a x :start i) 'list)))
  ((b c b d c b e)
   (a b c b d c b e)
   (a b c b d c b e)
   (a b c b d c b e)
   (a b c a b d c b e)
   (a b c a b d c b e)
   (a b c a b d c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b a e)))

(deftest delete.queue.12
    (let* ((orig #[a b c a b d a c b a e]))
      (loop for i from 0 to 10
	    for x = (copy-seq orig)
	    collect (coerce (delete 'a x :start i :end nil) 'list)))
  ((b c b d c b e)
   (a b c b d c b e)
   (a b c b d c b e)
   (a b c b d c b e)
   (a b c a b d c b e)
   (a b c a b d c b e)
   (a b c a b d c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b a e)))

(deftest delete.queue.13
    (let* ((orig #[a b c a b d a c b a e]))
      (loop for i from 0 to 10
	    for x = (copy-seq orig)
	    collect (coerce (delete 'a x :start i :end 11) 'list)))
  ((b c b d c b e)
   (a b c b d c b e)
   (a b c b d c b e)
   (a b c b d c b e)
   (a b c a b d c b e)
   (a b c a b d c b e)
   (a b c a b d c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b a e)))

(deftest/sequence delete.queue.14
    (let* ((orig #[a b c a b d a c b a e])
           (x (copy-seq orig))
           (y (delete 'a x :end nil)))
      y)
  #[b c b d c b e])
 
(deftest delete.queue.15
    (let* ((orig #[a b c a b d a c b a e]))
      (loop for i from 0 to 9
	    for x = (copy-seq orig)
	    collect (coerce (delete 'a x :start i :end 9) 'list)))
  ((b c b d c b a e)
   (a b c b d c b a e)
   (a b c b d c b a e)
   (a b c b d c b a e)
   (a b c a b d c b a e)
   (a b c a b d c b a e)
   (a b c a b d c b a e)
   (a b c a b d a c b a e)
   (a b c a b d a c b a e)
   (a b c a b d a c b a e)))

(deftest delete.queue.16
    (let* ((orig #[a b c a b d a c b a e]))
      (loop for i from 0 to 10
	    for x = (copy-seq orig)
	    collect (coerce (delete 'a x :start i :end 11 :count 1) 'list)))
  ((b c a b d a c b a e)
   (a b c b d a c b a e)
   (a b c b d a c b a e)
   (a b c b d a c b a e)
   (a b c a b d c b a e)
   (a b c a b d c b a e)
   (a b c a b d c b a e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b e)
   (a b c a b d a c b a e)))

(deftest delete.queue.17
    (let* ((orig #[a b c a b d a c b a e]))
      (loop for i from 0 to 10
	    for x = (copy-seq orig)
	    collect (coerce (delete 'a x :start i :end (1+ i)) 'list)))
  ((  b c a b d a c b a e)
   (a b c a b d a c b a e)
   (a b c a b d a c b a e)
   (a b c   b d a c b a e)
   (a b c a b d a c b a e)
   (a b c a b d a c b a e)
   (a b c a b d   c b a e)
   (a b c a b d a c b a e)
   (a b c a b d a c b a e)
   (a b c a b d a c b   e)
   (a b c a b d a c b a e)))

#|
(deftest delete.queue.18
   (let* ((i (1+ most-positive-fixnum))
	  (orig (list i 0 i 1 i 2 3))
	  (x (copy-seq orig))
	  (y (delete (1+ most-positive-fixnum) x)))
     (and (sequence-equal orig x) y))
   (0 1 2 3))
|#

(deftest/sequence delete.queue.19
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (delete 1 x :key #'1-)))
      y)
  #[1 3 6 1 4 1 3 7])

(deftest/sequence delete.queue.20
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (delete 3 x :test #'>)))
      y)
  #[3 6 4 3 7])

(deftest/sequence delete.queue.21
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (delete 3 x :test '> :from-end t)))
      y)
  #[3 6 4 3 7])

(deftest/sequence delete.queue.22
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (delete 2 x :key nil)))
      y)
  #[1 3 6 1 4 1 3 7])

(deftest/sequence delete.queue.23
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (delete 1 x :key '1-)))
      y)
  #[1 3 6 1 4 1 3 7])

(deftest/sequence delete.queue.24
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (delete 3 x :test-not #'<=)))
      y)
  #[3 6 4 3 7])

(deftest/sequence delete.queue.25
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
	   (x (copy-seq orig))
	   (y (delete 3 x :test-not '<= :from-end t)))
      y)
  #[3 6 4 3 7])

(deftest/sequence delete.queue.26
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (delete 3 x :from-end t :start 1 :end 5)))
      y)
  #[1 2 2 6 1 2 4 1 3 2 7])

(deftest delete.queue.27
    (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
           (x (copy-seq orig))
           (y (delete 3 x :count -1)))
      (and (sequence-equal orig x)
           (sequence-equal x y)))
  t)

(deftest delete.queue.28
  (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
	 (x (copy-seq orig))
	 (y (delete 3 x :count -1000000000000)))
    (and (sequence-equal orig x)
	 (sequence-equal x y)))
  t)

(deftest/sequence delete.queue.29
  (let* ((orig #[1 2 3 2 6 1 2 4 1 3 2 7])
	 (x (copy-seq orig))
	 (y (delete 3 x :count 1000000000000)))
    y)
  #[1 2 2 6 1 2 4 1 2 7])

(deftest/sequence remove-if.queue.1
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (remove-if 'evenp x)))
      (and (sequence-equal orig x) y))
  #[1 3 5])

(deftest/sequence remove-if.queue.2
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (remove-if #'evenp x :key '1+)))
      (and (sequence-equal orig x) y))
  #[2 4 6])

(deftest/sequence remove-if.queue.3
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (remove-if #'evenp x :start 2 :end nil)))
      (and (sequence-equal orig x) y))
  #[1 2 3 5])

(deftest/sequence remove-if.queue.4
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (remove-if #'evenp x :start 1 :end 3)))
      (and (sequence-equal orig x) y))
  #[1 3 4 5 6])

(deftest/sequence remove-if.queue.5
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (remove-if #'evenp x :start 1 :end 5 :count 1)))
      (and (sequence-equal orig x) y))
  #[1 3 4 5 6])

(deftest/sequence remove-if.queue.6
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (remove-if #'evenp x :start 1 :end 5 :count 1 :from-end t)))
      (and (sequence-equal orig x) y))
  #[1 2 3 5 6])

(deftest/sequence delete-if.queue.1
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (delete-if 'evenp x)))
      y)
  #[1 3 5])

(deftest/sequence delete-if.queue.2
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (delete-if #'evenp x :key '1+)))
      y)
  #[2 4 6])

(deftest/sequence delete-if.queue.3
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (delete-if #'evenp x :start 2 :end nil)))
      y)
  #[1 2 3 5])

(deftest/sequence delete-if.queue.4
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (delete-if #'evenp x :start 1 :end 3)))
      y)
  #[1 3 4 5 6])

(deftest/sequence delete-if.queue.5
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (delete-if #'evenp x :start 1 :end 5 :count 1)))
      y)
  #[1 3 4 5 6])

(deftest/sequence delete-if.queue.6
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (delete-if #'evenp x :start 1 :end 5 :count 1 :from-end t)))
      y)
  #[1 2 3 5 6])

(deftest/sequence remove-if-not.queue.1
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (remove-if-not 'evenp x)))
      (and (sequence-equal orig x) y))
  #[2 4 6])

(deftest/sequence remove-if-not.queue.2
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (remove-if-not #'evenp x :key '1+)))
      (and (sequence-equal orig x) y))
  #[1 3 5])

(deftest/sequence remove-if-not.queue.3
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (remove-if-not #'evenp x :start 2 :end nil)))
      (and (sequence-equal orig x) y))
  #[1 2 4 6])

(deftest/sequence remove-if-not.queue.4
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (remove-if-not #'evenp x :start 1 :end 3)))
      (and (sequence-equal orig x) y))
  #[1 2 4 5 6])

(deftest/sequence remove-if-not.queue.5
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (remove-if-not #'evenp x :start 1 :end 5 :count 1)))
      (and (sequence-equal orig x) y))
  #[1 2 4 5 6])

(deftest/sequence remove-if-not.queue.6
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (remove-if-not #'evenp x :start 1 :end 5 :count 1 :from-end t)))
      (and (sequence-equal orig x) y))
  #[1 2 3 4 6])

(deftest/sequence delete-if-not.queue.1
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (delete-if-not 'evenp x)))
      y)
  #[2 4 6])

(deftest/sequence delete-if-not.queue.2
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (delete-if-not #'evenp x :key '1+)))
      y)
  #[1 3 5])

(deftest/sequence delete-if-not.queue.3
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (delete-if-not #'evenp x :start 2 :end nil)))
      y)
  #[1 2 4 6])

(deftest/sequence delete-if-not.queue.4
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (delete-if-not #'evenp x :start 1 :end 3)))
      y)
  #[1 2 4 5 6])

(deftest/sequence delete-if-not.queue.5
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (delete-if-not #'evenp x :start 1 :end 5 :count 1)))
      y)
  #[1 2 4 5 6])

(deftest/sequence delete-if-not.queue.6
    (let* ((orig #[1 2 3 4 5 6])
	   (x (copy-seq orig))
	   (y (delete-if-not #'evenp x :start 1 :end 5 :count 1 :from-end t)))
      y)
  #[1 2 3 4 6])

(deftest delete.list.1
    (let ((orig (list 1 1 1)))
      (sequence:delete 1 orig))
  nil)
