(in-package "SEQUENCE-TESTS")

(deftest/sequence sort.queue.1
    (let ((a (copy-seq #[1 4 2 5 3])))
      (sort a #'<))
  #[1 2 3 4 5])

(deftest/sequence sort.queue.2
    (let ((a (copy-seq #[1 4 2 5 3])))
      (sort a #'< :key #'-))
  #[5 4 3 2 1])

(deftest/sequence sort.queue.3
    (let ((a (copy-seq #[1 4 2 5 3])))
      (sort a #'(lambda (x y) nil))
      (sort a #'<))
  #[1 2 3 4 5])

(deftest sort.queue.4
    (loop repeat 100
          always (let ((a (copy-seq #[1 2 3 4 5 6 7 8 9 0]))
                       (cmp (make-array '(10 10))))
                   (loop for i from 0 to 9 do
                         (loop for j from 0 to 9 do
                               (setf (aref cmp i j) 
                                     (zerop (logand (random 1024) 512)))))
                   (setq a (sort a #'(lambda (i j) (aref cmp i j))))
                   (and (eql (length a) 10)
                        (sequence-equal (sort a #'<) #[0 1 2 3 4 5 6 7 8 9]))))
  t)	

(deftest/sequence stable-sort.queue.1
    (let ((a (copy-seq #[1 4 2 5 3])))
      (stable-sort a #'<))
  #[1 2 3 4 5])

(deftest/sequence stable-sort.queue.2
    (let ((a (copy-seq #[1 4 2 5 3])))
      (stable-sort a #'< :key #'-))
  #[5 4 3 2 1])

(deftest/sequence stable-sort.queue.3
    (let ((a (copy-seq #[1 4 2 5 3])))
      (stable-sort a #'(lambda (x y) nil))
      (stable-sort a #'<))
  #[1 2 3 4 5])

(deftest stable-sort.queue.4
    (let ((a (copy-seq #[(1 a) (2 a) (1 b) (2 b) (1 c) (2 c)])))
      (map 'list #'cadr (stable-sort a #'(lambda (x y) (< (car x) (car y))))))
  (a b c a b c))

(deftest stable-sort.queue.5
    (let ((a (reverse #[(1 a) (2 a) (1 b) (2 b) (1 c) (2 c)])))
      (map 'list #'cadr (stable-sort a #'(lambda (x y) (< (car x) (car y))))))
  (c b a c b a))
