(in-package "SEQUENCE-TESTS")

(deftest/sequence subseq.queue.1
    (subseq #[a b c d e] 0 0)
  #[])

(deftest/sequence subseq.queue.2
    (subseq #[a b c] 0)
  #[a b c])

(deftest/sequence subseq.queue.3
    (subseq #[a b c] 1)
  #[b c])

(deftest/sequence subseq.queue.7
    (let ((x (copy-seq #[0 1 2 3 4 5 6 7 8 9])))
      (setf (subseq x 0 3) (list 'a 'b 'c))
      x)
  #[a b c 3 4 5 6 7 8 9])

(deftest/sequence subseq.queue.8
    (let* ((x #[a b c d e])
	   (y (copy-seq x)))
      (setf (subseq y 0) '(f g h))
      x)
  #[a b c d e])

(deftest/sequence subseq.queue.8a
    (let* ((x #[a b c d e])
	   (y (copy-seq x)))
      (setf (subseq y 0) '(f g h))
      y)
  #[f g h d e])

(deftest/sequence subseq.queue.9
    (let* ((x #[a b c d e])
	   (y (copy-seq x)))
      (setf (subseq y 1 3) '(1 2 3))
      x)
  #[a b c d e])

(deftest/sequence subseq.queue.9a
    (let* ((x #[a b c d e])
	   (y (copy-seq x)))
      (setf (subseq y 1 3) '(1 2 3))
      y)
  #[a 1 2 d e])

(deftest/sequence subseq.queue.10
    (let* ((x #[a b c d e])
	   (y (copy-seq x)))
      (setf (subseq y 5) '(1 2 3 4 5))
      x)
  #[a b c d e])

(deftest/sequence subseq.queue.10a
    (let* ((x #[a b c d e])
	   (y (copy-seq x)))
      (setf (subseq y 5) '(1 2 3 4 5))
      y)
  #[a b c d e])

(deftest/sequence subseq.queue.11
    (let* ((x #[a b c d e])
	   (y (copy-seq x)))
      (setf (subseq y 2 5) '(1))
      x)
  #[a b c d e])

(deftest/sequence subseq.queue.11a
    (let* ((x #[a b c d e])
	   (y (copy-seq x)))
      (setf (subseq y 2 5) '(1))
      y)
  #[a b 1 d e])

(deftest/sequence subseq.queue.12
    (let* ((x #[a b c d e])
	   (y (copy-seq x)))
      (setf (subseq y 0 0) '(1 2))
      x)
  #[a b c d e])

(deftest/sequence subseq.queue.12a
    (let* ((x #[a b c d e])
	   (y (copy-seq x)))
      (setf (subseq y 0 0) '(1 2))
      y)
  #[a b c d e])



